ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.30 by root, Fri Feb 11 02:01:24 2011 UTC vs.
Revision 1.75 by root, Tue Aug 1 03:48:59 2023 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in (or to replace in your .staticperlrc)
5 5
6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9DLCACHE=
9 10
10# perl build variables 11# perl build variables
11MAKE=make 12MAKE=make
12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice 13PERL_VERSION=http://stableperl.schmorp.de/dist/latest.tar.gz # 5.12.5 and 5.8.9 are good choices for small builds
13PERL_CC=cc 14PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments 15PERL_CONFIGURE="" # additional Configure arguments
15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -D_GNU_SOURCE -DNDEBUG" 16PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-g -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 17PERL_OPTIMIZE="-Os" # -Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 18
18ARCH="$(uname -m)" 19ARCH="$(uname -m)"
19 20
20case "$ARCH" in 21#case "$ARCH" in
21 i*86 | x86_64 | amd64 ) 22# i*86 | x86_64 | amd64 )
22 PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64 23# PERL_OPTIMIZE="$PERL_OPTIMIZE -mpush-args -mno-inline-stringops-dynamically -mno-align-stringops -mno-ieee-fp" # x86/amd64
23 case "$ARCH" in 24# case "$ARCH" in
24 i*86 ) 25# i*86 )
25 PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only 26# PERL_OPTIMIZE="$PERL_OPTIMIZE -fomit-frame-pointer -march=pentium3 -mtune=i386" # x86 only
26 ;; 27# ;;
27 esac 28# esac
28 ;; 29# ;;
29esac 30#esac
30 31
31# -Wl,--gc-sections makes it impossible to check for undefined references 32# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 33# for some reason so we need to patch away the "-no" after Configure and before make :/
33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 34# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 35#PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LDFLAGS=
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 37PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 38
37# some configuration options for modules 39# some configuration options for modules
38PERL_MM_USE_DEFAULT=1 40PERL_MM_USE_DEFAULT=1
41PERL_MM_OPT="MAN1PODS= MAN3PODS="
39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 42#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 43#EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS 44export PERL_MM_USE_DEFAULT PERL_MM_OPT
42 45
43# which extra modules to install by default from CPAN that are 46# which extra modules to install by default from CPAN that are
44# required by mkbundle 47# required by mkbundle
45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 48STATICPERL_MODULES="ExtUtils::MakeMaker ExtUtils::CBuilder common::sense Pod::Strip PPI PPI::XS Pod::Usage"
46 49
47# which extra modules you might want to install 50# which extra modules you might want to install
48EXTRA_MODULES="" 51EXTRA_MODULES=""
49 52
50# overridable functions 53# overridable functions
51preconfigure() { : ; } 54preconfigure() { : ; }
55patchconfig() { : ; }
52postconfigure() { : ; } 56postconfigure() { : ; }
53postbuild() { : ; } 57postbuild() { : ; }
58postcpanconfig() { : ; }
54postinstall() { : ; } 59postinstall() { : ; }
55 60
56# now source user config, if any 61# now source user config, if any
57if [ "$STATICPERLRC" ]; then 62if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC" 63 . "$STATICPERLRC"
59else 64else
63fi 68fi
64 69
65############################################################################# 70#############################################################################
66# support 71# support
67 72
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 73# work around ExtUtils::CBuilder and others
74export CC="$PERL_CC"
75export CFLAGS="$PERL_CFLAGS"
76export LD="$PERL_CC"
77export LDFLAGS="$PERL_LDFLAGS"
78unset LIBS
79
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 80PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70 81
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 82unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
83unset PERL_MB_OPT
72LC_ALL=C; export LC_ALL # just to be on the safe side 84LC_ALL=C; export LC_ALL # just to be on the safe side
85
86# prepend PATH - not required by staticperl itself, but might make
87# life easier when working in e.g. "staticperl cpan / look"
88PATH="$PERL_PREFIX/perl/bin:$PATH"
73 89
74# set version in a way that Makefile.PL can extract 90# set version in a way that Makefile.PL can extract
75VERSION=VERSION; eval \ 91VERSION=VERSION; eval \
76$VERSION="1.0" 92$VERSION="1.46"
77
78BZ2=bz2
79BZIP2=bzip2
80 93
81fatal() { 94fatal() {
82 printf -- "\nFATAL: %s\n\n" "$*" >&2 95 printf -- "\nFATAL: %s\n\n" "$*" >&2
83 exit 1 96 exit 1
84} 97}
124 137
125############################################################################# 138#############################################################################
126# download/configure/compile/install perl 139# download/configure/compile/install perl
127 140
128clean() { 141clean() {
129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 142 rm -rf "$STATICPERL/src"
130} 143}
131 144
132realclean() { 145realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall" 146 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install" 147 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure" 148 rm -f "$STATICPERL/src/perl/staticstamp.configure"
136} 149}
137 150
138fetch() { 151fetch() {
152(
139 rcd "$STATICPERL" 153 rcd "$STATICPERL"
140 154
141 mkdir -p src 155 mkdir -p src
142 rcd src 156 rcd src
143 157
144 if ! [ -d "perl-$PERL_VERSION" ]; then 158 if ! [ -d "perl" ]; then
145 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then 159 rm -rf unpack
160 mkdir -p unpack
146 161
162 case "$PERL_VERSION" in
163 *:* )
164 # url
165 PERLURL="$PERL_VERSION"
166 PERLTAR="$(basename "$PERL_VERSION")"
167 ;;
168 /* )
169 # directory
170 verbose "copying $PERL_VERSION"
171 cp -Rp "$PERL_VERSION/." unpack/.
172 chmod -R u+w unpack
173 mv unpack perl
174 return
175 ;;
176 * )
147 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2" 177 PERLURL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.bz2"
178 PERLTAR=perl-$PERL_VERSION.tar.bz2
179 ;;
180 esac
148 181
182 if ! [ -e "$PERLTAR" ]; then
149 verblock <<EOF 183 verblock <<EOF
150downloading perl 184downloading perl
185
186trying to download from $PERLURL
187
188you can configure a download cache directory via DLCACHE
189in your .staticperlrc to avoid repeated downloads.
190
151to manually download perl yourself, place 191to manually download perl yourself, place a suitable tarball in
152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 192$DLCACHE/$PERLTAR
153trying $URL
154EOF
155 193
194either curl or wget is required for automatic download.
195curl is tried first, then wget.
196EOF
197
156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 198 rm -f $PERLTAR~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 199 { [ "$DLCACHE" ] && cp "$DLCACHE"/$PERLTAR $PERLTAR~ >/dev/null 2>&1; } \
158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 200 || wget -O $PERLTAR~ "$PERLURL" \
201 || curl -f >$PERLTAR~ "$PERLURL" \
159 || fatal "$URL: unable to download" 202 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2 203 rm -f $PERLTAR
161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 204 mv $PERLTAR~ $PERLTAR
205 if [ "$DLCACHE" ]; then
206 mkdir -p "$DLCACHE"
207 cp $PERLTAR "$DLCACHE"/$PERLTAR~$$~ && \
208 mv "$DLCACHE"/$PERLTAR~$$~ "$DLCACHE"/$PERLTAR
209 fi
162 fi 210 fi
163 211
164 verblock <<EOF 212 verblock <<EOF
165unpacking perl 213unpacking perl
166EOF 214EOF
167 215
168 mkdir -p unpack 216 case "$PERLTAR" in
169 rm -rf unpack/perl-$PERL_VERSION 217 *.xz ) UNCOMPRESS="xz -d" ;;
170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \ 218 *.lzma ) UNCOMPRESS="lzma -d" ;;
219 *.bz2 ) UNCOMPRESS="bzip2 -d" ;;
220 *.gz ) UNCOMPRESS="gzip -d" ;;
221 *.tar ) UNCOMPRESS="cat" ;;
222 * )
223 fatal "don't know hot to uncompress $PERLTAR,\nonly tar, tar.gz, tar.bz2, tar.lzma and tar.xz are supported."
224 exit 1
225 ;;
226 esac
227
228 <"$PERLTAR" $UNCOMPRESS -d | ( cd unpack && tar xf - ) \
171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking" 229 || fatal "$PERLTAR: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION 230
173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 231 if [ -d unpack/*/ ]; then
232 chmod -R u+w unpack/*/
233 mv unpack/*/ perl
174 rmdir -p unpack 234 rmdir -p unpack
235 else
236 fatal "unpacking $PERLTAR did not result in a single directory, don't know how to handle this"
237 fi
238
239 rm "$PERLTAR"
175 fi 240 fi
241) || exit
176} 242}
177 243
178# similar to GNU-sed -i or perl -pi 244# similar to GNU-sed -i or perl -pi
179sedreplace() { 245sedreplace() {
180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 246 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
207EOF 273EOF
208 exit 1 274 exit 1
209} 275}
210 276
211configure() { 277configure() {
278(
212 fetch 279 fetch
213 280
214 rcd "$STATICPERL/src/perl-$PERL_VERSION" 281 rcd "$STATICPERL/src/perl"
215 282
216 [ -e staticstamp.configure ] && return 283 [ -e staticstamp.configure ] && return
217 284
218 verblock <<EOF 285 verblock <<EOF
219configuring $STATICPERL/src/perl-$PERL_VERSION 286configuring $STATICPERL/src/perl
220EOF 287EOF
221 288
222 rm -f "$PERL_PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
223 290
224 "$MAKE" distclean >/dev/null 2>&1 291 "$MAKE" distclean >/dev/null 2>&1
227 294
228 # I hate them for this 295 # I hate them for this
229 grep -q -- -fstack-protector Configure && \ 296 grep -q -- -fstack-protector Configure && \
230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 297 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231 298
232 preconfigure 299 # what did that bloke think
300 grep -q -- usedl=.define hints/darwin.sh && \
301 sedreplace '/^usedl=.define.;$/d' hints/darwin.sh
302
303 preconfigure || fatal "preconfigure hook failed"
233 304
234# trace configure \ 305# trace configure \
235 sh Configure -Duselargefiles \ 306 sh Configure -Duselargefiles \
236 -Uuse64bitint \ 307 -Uuse64bitint \
237 -Dusemymalloc=n \ 308 -Dusemymalloc=n \
260 -Usiteman3dir \ 331 -Usiteman3dir \
261 -Dpager=/usr/bin/less \ 332 -Dpager=/usr/bin/less \
262 -Demail="$EMAIL" \ 333 -Demail="$EMAIL" \
263 -Dcf_email="$EMAIL" \ 334 -Dcf_email="$EMAIL" \
264 -Dcf_by="$EMAIL" \ 335 -Dcf_by="$EMAIL" \
265 -UDEBUGGING \
266 $PERL_CONFIGURE \ 336 $PERL_CONFIGURE \
267 -Duseperlio \ 337 -Duseperlio \
338 -Uversiononly \
268 -dE || configure_failure 339 -dE || configure_failure
269 340
270 sedreplace ' 341 sedreplace '
271 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 342 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
272 s/ *-fno-stack-protector */ /g 343 s/ *-fno-stack-protector */ /g
273 ' config.sh 344 ' config.sh
274 345
346 patchconfig || fatal "patchconfig hook failed"
347
275 sh Configure -S || fatal "Configure -S failed" 348 sh Configure -S || fatal "Configure -S failed"
276 349
277 postconfigure || fatal "postconfigure hook failed" 350 postconfigure || fatal "postconfigure hook failed"
278 351
279 touch staticstamp.configure 352 : > staticstamp.configure
353) || exit
354}
355
356write_shellscript() {
357 {
358 echo "#!/bin/sh"
359 echo "STATICPERL=\"$STATICPERL\""
360 echo "PERL_PREFIX=\"$PERL_PREFIX\""
361 echo "MAKE=\"$MAKE\""
362 cat
363 } >"$PERL_PREFIX/bin/$1"
364 chmod 755 "$PERL_PREFIX/bin/$1"
280} 365}
281 366
282build() { 367build() {
368(
283 configure 369 configure
284 370
285 rcd "$STATICPERL/src/perl-$PERL_VERSION" 371 rcd "$STATICPERL/src/perl"
286 372
287 verblock <<EOF 373 verblock <<EOF
288building $STATICPERL/src/perl-$PERL_VERSION 374building $STATICPERL/src/perl
289EOF 375EOF
290 376
291 rm -f "$PERL_PREFIX/staticstamp.install" 377 rm -f "$PERL_PREFIX/staticstamp.install"
292 378
293 "$MAKE" || fatal "make: error while building perl" 379 "$MAKE" || fatal "make: error while building perl"
294 380
295 postbuild || fatal "postbuild hook failed" 381 postbuild || fatal "postbuild hook failed"
382) || exit
383}
384
385_postinstall() {
386 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
387 NOCHECK_INSTALL=+
388 instcpan $STATICPERL_MODULES
389 [ "$EXTRA_MODULES" ] && instcpan $EXTRA_MODULES
390
391 postinstall || fatal "postinstall hook failed"
392
393 : > "$PERL_PREFIX/staticstamp.postinstall"
394 fi
296} 395}
297 396
298install() { 397install() {
398(
299 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then 399 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
300 build 400 build
301 401
302 verblock <<EOF 402 verblock <<EOF
303installing $STATICPERL/src/perl-$PERL_VERSION 403installing $STATICPERL/src/perl
304to $PERL_PREFIX 404to $PERL_PREFIX
305EOF 405EOF
306 406
307 ln -sf "perl/bin/" "$STATICPERL/bin" 407 ln -sf "perl/bin/" "$STATICPERL/bin"
308 ln -sf "perl/lib/" "$STATICPERL/lib" 408 ln -sf "perl/lib/" "$STATICPERL/lib"
309 409
410 mkdir "$STATICPERL/patched"
411
310 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 412 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
311 rm -rf "$PERL_PREFIX" # by this rm -rf 413 rm -rf "$PERL_PREFIX" # by this rm -rf
312 414
415 rcd "$STATICPERL/src/perl"
416
313 "$MAKE" install || fatal "make install: error while installing" 417 "$MAKE" install || fatal "make install: error while installing"
314 418
315 rcd "$PERL_PREFIX" 419 rcd "$PERL_PREFIX"
316 420
317 # create a "make install" replacement for CPAN 421 # create a "make install" replacement for CPAN
318 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 422 write_shellscript SP-make-make <<'end_of_make'
319"$MAKE" || exit 423#CAT make-make.sh
424end_of_make
320 425
321if find blib/arch/auto -type f | grep -q -v .exists; then 426 # create a "make install" replacement for CPAN
322 echo Probably an XS module, rebuilding perl 427 write_shellscript SP-make-install-make <<'end_of_make_install_make'
323 if "$MAKE" perl; then 428#CAT make-install-make.sh
324 mv perl "$PERL_PREFIX"/bin/perl~ \ 429end_of_make_install_make
325 && rm -f "$PERL_PREFIX"/bin/perl \
326 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
327 "$MAKE" -f Makefile.aperl map_clean
328 else
329 "$MAKE" -f Makefile.aperl map_clean
330 exit 1
331 fi
332fi
333 430
334"$MAKE" install UNINST=1 431 # create a "patch modules" helper
335EOF 432 write_shellscript SP-patch-postinstall <<'end_of_patch_postinstall'
336 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 433#CAT patch-postinstall.sh
434end_of_patch_postinstall
337 435
436 # immediately use it
437 "$PERL_PREFIX/bin/SP-patch-postinstall"
438
338 # trick CPAN into avoiding ~/.cpan completely 439 # help to trick CPAN into avoiding ~/.cpan completely
339 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 440 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
340 441
442 # we call cpan with -MCPAN::MyConfig in this script, which
443 # is strictly unnecessary as we have to patch CPAN anyway,
444 # so consider it "for good measure".
341 "$PERL_PREFIX"/bin/perl -MCPAN -e ' 445 "$PERL_PREFIX"/bin/perl -MCPAN::MyConfig -MCPAN -e '
342 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 446 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
447 CPAN::Shell->o (conf => pushy_https => "0");
343 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 448 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
344 CPAN::Shell->o (conf => q<init>); 449 CPAN::Shell->o (conf => q<init>);
345 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 450 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
346 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 451 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
347 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 452 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
348 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 453 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
349 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 454 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
455 CPAN::Shell->o (conf => q<makepl_arg>, "MAP_TARGET=perl");
456 CPAN::Shell->o (conf => q<make>, "'"$PERL_PREFIX"'/bin/SP-make-make");
350 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install"); 457 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/SP-make-install-make");
351 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 458 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
352 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 459 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<yes>);
460 CPAN::Shell->o (conf => q<recommends_policy>, q<0>);
461 CPAN::Shell->o (conf => q<suggests_policy>, q<0>);
462 CPAN::Shell->o (conf => q<prefer_installer>, q<EUMM>);
353 CPAN::Shell->o (conf => q<commit>); 463 CPAN::Shell->o (conf => q<commit>);
354 ' || fatal "error while initialising CPAN" 464 ' || fatal "error while initialising CPAN"
355 465
466 postcpanconfig
467
356 touch "$PERL_PREFIX/staticstamp.install" 468 : > "$PERL_PREFIX/staticstamp.install"
357 fi 469 fi
358 470
471 _postinstall
472) || exit
473}
474
475import() {
476(
477 IMPORT="$1"
478
479 rcd "$STATICPERL"
480
359 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then 481 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
360 NOCHECK_INSTALL=+ 482 verblock <<EOF
361 instcpan $STATICPERL_MODULES 483import perl from $IMPORT to $STATICPERL
362 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 484EOF
363 485
364 postinstall || fatal "postinstall hook failed" 486 rm -rf bin cpan lib patched perl src
487 mkdir -m 755 perl perl/bin
488 ln -s perl/bin/ bin
489 ln -s "$IMPORT" perl/bin/
365 490
491 echo "$IMPORT" > "$PERL_PREFIX/.import"
492
366 touch "$PERL_PREFIX/staticstamp.postinstall" 493 : > "$PERL_PREFIX/staticstamp.install"
367 fi 494 fi
495
496 _postinstall
497) || exit
368} 498}
369 499
370############################################################################# 500#############################################################################
371# install a module from CPAN 501# install a module from CPAN
372 502
373instcpan() { 503instcpan() {
374 [ $NOCHECK_INSTALL ] || install 504 [ $NOCHECK_INSTALL ] || install
375 505
376 verblock <<EOF 506 verblock <<EOF
377installing modules from CPAN 507installing modules from CPAN
378$@ 508$*
379EOF 509EOF
380 510
381 for mod in "$@"; do 511 MYCONFIG=
382 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 512 [ -e "$PERL_PREFIX/.import" ] || MYCONFIG=-MCPAN::MyConfig
383 || fatal "$mod: unable to install from CPAN" 513
384 done 514 "$PERL_PREFIX"/bin/perl $MYCONFIG -MCPAN -e 'notest (install => $_) for @ARGV' -- "$@" | tee "$STATICPERL/instcpan.log"
515
516 if grep -q " -- NOT OK\$" "$STATICPERL/instcpan.log"; then
517 fatal "failure while installing modules from CPAN ($*)"
518 fi
385 rm -rf "$STATICPERL/build" 519 rm -f "$STATICPERL/instcpan.log"
386} 520}
387 521
388############################################################################# 522#############################################################################
389# install a module from unpacked sources 523# install a module from unpacked sources
390 524
391instsrc() { 525instsrc() {
392 [ $NOCHECK_INSTALL ] || install 526 [ $NOCHECK_INSTALL ] || install
393 527
394 verblock <<EOF 528 verblock <<EOF
395installing modules from source 529installing modules from source
396$@ 530$*
397EOF 531EOF
398 532
399 for mod in "$@"; do 533 for mod in "$@"; do
400 echo 534 echo
401 echo $mod 535 echo $mod
403 rcd $mod 537 rcd $mod
404 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1 538 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
405 "$MAKE" distclean >/dev/null 2>&1 539 "$MAKE" distclean >/dev/null 2>&1
406 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 540 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
407 "$MAKE" || fatal "$mod: error building module" 541 "$MAKE" || fatal "$mod: error building module"
408 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 542 "$PERL_PREFIX"/bin/SP-make-install-make install || fatal "$mod: error installing module"
409 "$MAKE" distclean >/dev/null 2>&1 543 "$MAKE" distclean >/dev/null 2>&1
410 exit 0 544 exit 0
411 ) || exit $? 545 ) || exit $?
412 done 546 done
413} 547}
439catmkbundle() { 573catmkbundle() {
440 { 574 {
441 read dummy 575 read dummy
442 echo "#!$PERL_PREFIX/bin/perl" 576 echo "#!$PERL_PREFIX/bin/perl"
443 cat 577 cat
444 } <<'MKBUNDLE' 578 } <<'end_of_mkbundle'
445#CAT mkbundle 579#CAT mkbundle
446MKBUNDLE 580end_of_mkbundle
447} 581}
448 582
449bundle() { 583bundle() {
584 MKBUNDLE="${MKBUNDLE:=$PERL_PREFIX/bin/SP-mkbundle}"
450 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 585 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
451 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 586 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
452 CACHE="$STATICPERL/cache" 587 CACHE="$STATICPERL/cache"
453 mkdir -p "$CACHE" 588 mkdir -p "$CACHE"
454 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@" 589 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
462 command="${1#--}"; shift 597 command="${1#--}"; shift
463 case "$command" in 598 case "$command" in
464 version ) 599 version )
465 echo "staticperl version $VERSION" 600 echo "staticperl version $VERSION"
466 ;; 601 ;;
467 fetch | configure | build | install | clean | realclean | distclean) 602 fetch | configure | build | install | clean | realclean | distclean )
468 ( "$command" ) || exit 603 ( "$command" ) || exit
604 ;;
605 import )
606 ( import "$1" ) || exit
607 shift
469 ;; 608 ;;
470 instsrc ) 609 instsrc )
471 ( instsrc "$@" ) || exit 610 ( instsrc "$@" ) || exit
472 exit 611 exit
473 ;; 612 ;;
474 instcpan ) 613 instcpan )
475 ( instcpan "$@" ) || exit 614 ( instcpan "$@" ) || exit
476 exit 615 exit
477 ;; 616 ;;
617 perl )
618 ( install ) || exit
619 exec "$PERL_PREFIX/bin/perl" "$@"
620 exit
621 ;;
478 cpan ) 622 cpan )
479 ( install ) || exit 623 ( install ) || exit
624 PERL="$PERL_PREFIX/bin/perl"
625 export PERL
480 "$PERL_PREFIX/bin/cpan" "$@" 626 exec "$PERL_PREFIX/bin/cpan" "$@"
481 exit 627 exit
482 ;; 628 ;;
483 mkbundle ) 629 mkbundle )
484 ( install ) || exit 630 ( install ) || exit
485 bundle "$@" 631 bundle "$@"

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines